#ifndef __X10_LANG_RUNTIME__X10RTSTATS_H
#define __X10_LANG_RUNTIME__X10RTSTATS_H

#include <x10rt.h>


#define X10_LANG_ANY_H_NODEPS
#include <x10/lang/Any.h>
#undef X10_LANG_ANY_H_NODEPS
#define X10_LANG_ANY_H_NODEPS
#include <x10/lang/Any.h>
#undef X10_LANG_ANY_H_NODEPS
#define X10_LANG_RUNTIME__X10RTMESSAGESTATS_H_NODEPS
#include <x10/lang/Runtime__X10RTMessageStats.h>
#undef X10_LANG_RUNTIME__X10RTMESSAGESTATS_H_NODEPS
#define X10_LANG_LONG_H_NODEPS
#include <x10/lang/Long.h>
#undef X10_LANG_LONG_H_NODEPS
namespace x10 { namespace lang { 
class Runtime__X10RTMessageStats;
} } 
namespace x10 { namespace lang { 
class Long;
} } 
namespace x10 { namespace lang { 
class String;
} } 
namespace x10 { namespace compiler { 
class Native;
} } 
namespace x10 { namespace compiler { 
class NonEscaping;
} } 
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace lang { 

class Runtime__X10RTStats   {
    public:
    RTT_H_DECLS_STRUCT
    
    x10::lang::Runtime__X10RTStats* operator->() { return this; }
    
    static x10aux::itable_entry _itables[2];
    
    x10aux::itable_entry* _getITables() { return _itables; }
    
    static x10::lang::Any::itable<x10::lang::Runtime__X10RTStats > _itable_0;
    
    static x10aux::itable_entry _iboxitables[2];
    
    x10aux::itable_entry* _getIBoxITables() { return _iboxitables; }
    
    static x10::lang::Runtime__X10RTStats _alloc(){x10::lang::Runtime__X10RTStats t; return t; }
    
    void _constructor();
    
    static x10::lang::Runtime__X10RTStats _make();
    
    void _constructor(x10::lang::Runtime__X10RTMessageStats msg, x10::lang::Runtime__X10RTMessageStats put,
                      x10_long putCopiedBytesSent, x10_long putCopiedBytesReceived,
                      x10::lang::Runtime__X10RTMessageStats get,
                      x10_long getCopiedBytesSent, x10_long getCopiedBytesReceived);
    
    static x10::lang::Runtime__X10RTStats _make(x10::lang::Runtime__X10RTMessageStats msg,
                                                x10::lang::Runtime__X10RTMessageStats put,
                                                x10_long putCopiedBytesSent,
                                                x10_long putCopiedBytesReceived,
                                                x10::lang::Runtime__X10RTMessageStats get,
                                                x10_long getCopiedBytesSent,
                                                x10_long getCopiedBytesReceived);
    
    x10::lang::Runtime__X10RTMessageStats FMGL(msg);
    
    x10::lang::Runtime__X10RTMessageStats FMGL(put);
    
    x10_long FMGL(putCopiedBytesSent);
    
    x10_long FMGL(putCopiedBytesReceived);
    
    x10::lang::Runtime__X10RTMessageStats FMGL(get);
    
    x10_long FMGL(getCopiedBytesSent);
    
    x10_long FMGL(getCopiedBytesReceived);
    
    x10::lang::Runtime__X10RTStats __plus() {
        
        //#line 218 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/lang/Runtime.x10": x10.ast.X10Return_c
        return (*this);
        
    }
    x10::lang::Runtime__X10RTStats __minus();
    x10::lang::Runtime__X10RTStats __plus(x10::lang::Runtime__X10RTStats that);
    x10aux::ref<x10::lang::Any> __minus(x10::lang::Runtime__X10RTStats that);
    x10aux::ref<x10::lang::String> toString();
    x10aux::ref<x10::lang::String> typeName();
    x10_int hashCode();
    x10_boolean equals(x10aux::ref<x10::lang::Any> other);
    x10_boolean equals(x10::lang::Runtime__X10RTStats other) {
        
        //#line 185 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/lang/Runtime.x10": x10.ast.X10Return_c
        return (x10aux::struct_equals((*this)->FMGL(msg),
                                      other->FMGL(msg))) &&
        (x10aux::struct_equals((*this)->FMGL(put), other->
                                                     FMGL(put))) &&
        (x10aux::struct_equals((*this)->FMGL(putCopiedBytesSent),
                               other->FMGL(putCopiedBytesSent))) &&
        (x10aux::struct_equals((*this)->FMGL(putCopiedBytesReceived),
                               other->FMGL(putCopiedBytesReceived))) &&
        (x10aux::struct_equals((*this)->FMGL(get), other->
                                                     FMGL(get))) &&
        (x10aux::struct_equals((*this)->FMGL(getCopiedBytesSent),
                               other->FMGL(getCopiedBytesSent))) &&
        (x10aux::struct_equals((*this)->FMGL(getCopiedBytesReceived),
                               other->FMGL(getCopiedBytesReceived)));
        
    }
    x10_boolean _struct_equals(x10aux::ref<x10::lang::Any> other);
    x10_boolean _struct_equals(x10::lang::Runtime__X10RTStats other) {
        
        //#line 185 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/lang/Runtime.x10": x10.ast.X10Return_c
        return (x10aux::struct_equals((*this)->FMGL(msg),
                                      other->FMGL(msg))) &&
        (x10aux::struct_equals((*this)->FMGL(put), other->
                                                     FMGL(put))) &&
        (x10aux::struct_equals((*this)->FMGL(putCopiedBytesSent),
                               other->FMGL(putCopiedBytesSent))) &&
        (x10aux::struct_equals((*this)->FMGL(putCopiedBytesReceived),
                               other->FMGL(putCopiedBytesReceived))) &&
        (x10aux::struct_equals((*this)->FMGL(get), other->
                                                     FMGL(get))) &&
        (x10aux::struct_equals((*this)->FMGL(getCopiedBytesSent),
                               other->FMGL(getCopiedBytesSent))) &&
        (x10aux::struct_equals((*this)->FMGL(getCopiedBytesReceived),
                               other->FMGL(getCopiedBytesReceived)));
        
    }
    x10::lang::Runtime__X10RTStats x10__lang__Runtime__X10RTStats____x10__lang__Runtime__X10RTStats__this(
      ) {
        
        //#line 185 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/lang/Runtime.x10": x10.ast.X10Return_c
        return (*this);
        
    }
    
    static void _serialize(x10::lang::Runtime__X10RTStats this_, x10aux::serialization_buffer& buf);
    
    static x10::lang::Runtime__X10RTStats _deserialize(x10aux::deserialization_buffer& buf) {
        x10::lang::Runtime__X10RTStats this_;
        this_->_deserialize_body(buf);
        return this_;
    }
    
    void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_LANG_RUNTIME__X10RTSTATS_H

namespace x10 { namespace lang { 
class Runtime__X10RTStats;
} } 

#ifndef X10_LANG_RUNTIME__X10RTSTATS_H_NODEPS
#define X10_LANG_RUNTIME__X10RTSTATS_H_NODEPS
#ifndef X10_LANG_RUNTIME__X10RTSTATS_H_GENERICS
#define X10_LANG_RUNTIME__X10RTSTATS_H_GENERICS
#endif // X10_LANG_RUNTIME__X10RTSTATS_H_GENERICS
#endif // __X10_LANG_RUNTIME__X10RTSTATS_H_NODEPS
